#include "Vinculum_Serial.h"
#include "WProgram.h"
#include "HardwareSerial.h"
#include <stdio.h>
#include <string.h>
Vinculum_Serial::Vinculum_Serial(int RTS, int CTS, int DT_ack, int DT_req, int DCD, int RI, int BaudRate){
  _RTS=RTS;
  _CTS=CTS;
  _DT_ack=DT_ack;
  _DT_req=DT_req;
  _DCD=DCD;
  _RI=RI;
  _BaudRate=BaudRate;
  pinMode(_RTS, INPUT);
  pinMode(_CTS, OUTPUT);
  pinMode(_DT_ack, INPUT);
  pinMode(_DT_req, OUTPUT);
  pinMode(_DCD, OUTPUT);
  pinMode(_RI, OUTPUT);
  Serial1.begin(9600);
}

void Vinculum_Serial::Config_Cmd(){
	Serial1.print("IPA\r");
}

void Vinculum_Serial::OpenDir(){
  Serial1.print("DIR\r");
}
void Vinculum_Serial::ChangeDir(char *FileName){
  Serial1.print("CD ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::MakeDir(char *FileName){
  Serial1.print("MKD ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::DeleteDir(char *FileName){
  Serial1.print("DLD ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::ListFile(char *FileName){
  Serial1.print("DIR ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::DeleteFile(char *FileName){
  Serial1.print("DLF ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::ReadFile(char *FileName){
  Serial1.print("RD ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::RenameFile_Dir(char *lastName, char *newName){
  Serial1.print("REN ");
  Serial1.print(lastName);
  Serial1.write(' ');
  Serial1.print(newName);
  Serial1.write('\r');
}
void Vinculum_Serial::CloseFile(char *FileName){
  Serial1.print("CLF ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::Open_ReadFile(char *FileName, char *Byte){
  Serial1.print("IPA\r");
  Serial1.print("OPR ");
  Serial1.print(FileName);
  Serial1.write('\r');
  Serial1.print("RDF ");
  Serial1.print(Byte);
  Serial1.write('\r');
  Serial1.print("CLF ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::CreateFile(char *FileName){
  Serial1.print("OPW ");
  Serial1.print(FileName);
  Serial1.write('\r');
  Serial1.print("CLF ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
void Vinculum_Serial::Write_CreateFile(char *FileName, char *data){
  Serial1.print("OPW ");
  Serial1.print(FileName);
  Serial1.write('\r');
  Serial1.print("WRF ");
  Serial1.print((char)strlen(data));
  Serial1.write('\r');
  Serial1.print(data);
  Serial1.print("CLF ");
  Serial1.print(FileName);
  Serial1.write('\r');
}
